indexing

	description:
		"Scanner for mime messages."

	standards:
		"Based on RFC 2822, 2045 and 2047."

	known_bugs:
		"1. B encoding not decoded."

	author: "Berend de Boer"
	date: "$Date: $"
	revision: "$Revision: $"


class

	EPX_MIME_SCANNER


inherit

	YY_COMPRESSED_SCANNER_SKELETON
		export
			{EPX_MIME_PARSER} yyEnd_of_file_character
		redefine
			make
		end

	UT_CHARACTER_CODES
		export {NONE} all end

	KL_CHARACTER_ROUTINES
		export
			{NONE} all
		end

	EPX_MIME_TOKENS
		export
			{NONE} all
		end


creation

	make


feature -- Status report

	valid_start_condition (sc: INTEGER): BOOLEAN is
			-- Is `sc' a valid start condition?
		do
			Result := (INITIAL <= sc and sc <= DATE)
		end

feature {NONE} -- Implementation

	yy_build_tables is
			-- Build scanner tables.
		do
			yy_nxt := yy_nxt_template
			yy_chk := yy_chk_template
			yy_base := yy_base_template
			yy_def := yy_def_template
			yy_ec := yy_ec_template
			yy_meta := yy_meta_template
			yy_accept := yy_accept_template
		end

	yy_execute_action (yy_act: INTEGER) is
			-- Execute semantic action.
		do
if yy_act <= 58 then
if yy_act <= 29 then
if yy_act <= 15 then
if yy_act <= 8 then
if yy_act <= 4 then
if yy_act <= 2 then
if yy_act = 1 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 75 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 75")
end
-- Ignore white space
else
	yy_column := yy_column + 3
--|#line 79 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 79")
end

							last_token := FN_BCC
							to_condition := STRUCTURED_FIELD_BODY
							
end
else
if yy_act = 3 then
	yy_column := yy_column + 2
--|#line 83 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 83")
end

							last_token := FN_CC
							to_condition := STRUCTURED_FIELD_BODY
							
else
	yy_column := yy_column + 19
--|#line 87 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 87")
end

							last_token := FN_CONTENT_DISPOSITION
							to_condition := MIME_FIELD_BODY
							
end
end
else
if yy_act <= 6 then
if yy_act = 5 then
	yy_column := yy_column + 14
--|#line 91 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 91")
end

							last_token := FN_CONTENT_LENGTH
							to_condition := MIME_FIELD_BODY
							
else
	yy_column := yy_column + 25
--|#line 95 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 95")
end

							last_token := FN_CONTENT_TRANSFER_ENCODING
							to_condition := MIME_FIELD_BODY
							
end
else
if yy_act = 7 then
	yy_column := yy_column + 12
--|#line 99 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 99")
end

							last_token := FN_CONTENT_TYPE
							to_condition := MIME_FIELD_BODY
							
else
	yy_column := yy_column + 4
--|#line 103 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 103")
end

							last_token := FN_DATE
							to_condition := STRUCTURED_FIELD_BODY
							
end
end
end
else
if yy_act <= 12 then
if yy_act <= 10 then
if yy_act = 9 then
	yy_column := yy_column + 4
--|#line 107 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 107")
end

							last_token := FN_FROM
							to_condition := STRUCTURED_FIELD_BODY
							
else
	yy_column := yy_column + 17
--|#line 111 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 111")
end

							last_token := FN_IF_MODIFIED_SINCE
							to_condition := STRUCTURED_FIELD_BODY
							
end
else
if yy_act = 11 then
	yy_column := yy_column + 10
--|#line 115 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 115")
end

							last_token := FN_MESSAGE_ID
							to_condition := STRUCTURED_FIELD_BODY
							
else
	yy_column := yy_column + 12
--|#line 119 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 119")
end

							last_token := FN_VERSION
							-- I want to see two integers.
							-- tspecials from RFC 2045 include token, so I
							-- just get an atom if parsed according to that syntax.
							to_condition := STRUCTURED_FIELD_BODY
							
end
end
else
if yy_act <= 14 then
if yy_act = 13 then
	yy_column := yy_column + 11
--|#line 132 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 132")
end

							last_token := FN_RESENT_FROM
							to_condition := STRUCTURED_FIELD_BODY
							
else
	yy_column := yy_column + 15
--|#line 136 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 136")
end

							last_token := FN_RESENT_REPLY_TO
							to_condition := STRUCTURED_FIELD_BODY
							
end
else
	yy_column := yy_column + 13
--|#line 140 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 140")
end

							last_token := FN_RESENT_SENDER
							to_condition := STRUCTURED_FIELD_BODY
							
end
end
end
else
if yy_act <= 22 then
if yy_act <= 19 then
if yy_act <= 17 then
if yy_act = 16 then
	yy_column := yy_column + 11
--|#line 144 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 144")
end

							last_token := FN_RETURN_PATH
							to_condition := STRUCTURED_FIELD_BODY
							
else
	yy_column := yy_column + 6
--|#line 148 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 148")
end

							last_token := FN_SENDER
							to_condition := STRUCTURED_FIELD_BODY
							
end
else
if yy_act = 18 then
	yy_column := yy_column + 2
--|#line 152 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 152")
end

							last_token := FN_TO
							to_condition := STRUCTURED_FIELD_BODY
							
else
	yy_column := yy_column + 17
--|#line 156 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 156")
end

							last_token := FN_TRANSFER_ENCODING
							to_condition := MIME_FIELD_BODY
							
end
end
else
if yy_act <= 21 then
if yy_act = 20 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 168 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 168")
end

							last_token := FIELD_NAME
							last_string_value := to_canonical_field_name (text)
							to_condition := UNSTRUCTURED_FIELD_BODY
							
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 174 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 174")
end
 -- include space, so it's already skipped
							create last_string_value.make (64)
							last_token := Colon_code
							if to_condition /= 0 then
								set_start_condition (to_condition)
							end
							
end
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 182 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 182")
end

							last_token := CRLF
							
end
end
else
if yy_act <= 26 then
if yy_act <= 24 then
if yy_act = 23 then
	yy_column := yy_column + 1
--|#line 190 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 190")
end

							set_start_condition (COMMENT)
							
else
	yy_column := yy_column + 1
--|#line 193 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 193")
end

							create last_string_value.make (32)
							set_start_condition (SC_DOMAIN_LITERAL)
							
end
else
if yy_act = 25 then
	yy_column := yy_column + 1
--|#line 197 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 197")
end
 --"
							create last_string_value.make (32)
							set_start_condition (SC_QUOTED_STRING)
							
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 201 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 201")
end
-- White space, ignore
end
end
else
if yy_act <= 28 then
if yy_act = 27 then
yy_set_column (1)
--|#line 202 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 202")
end
-- Folded-line white space, ignore
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 203 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 203")
end

							set_start_condition (INITIAL)
							to_condition := 0
							last_token := CRLF
							
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 208 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 208")
end
 --'
							last_token := MIME_ATOM
							if encoded_word_scanner.is_encoded_word (text) then
								last_string_value := encoded_word_scanner.decode_word (text)
							else
								last_string_value := text
							end
							
end
end
end
end
else
if yy_act <= 44 then
if yy_act <= 37 then
if yy_act <= 33 then
if yy_act <= 31 then
if yy_act = 30 then
	yy_column := yy_column + 1
--|#line 216 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 216")
end
 -- pass rest of stuff as is, perhaps exclude 8-bit chars??
							last_token := text.item (1).code
							
else
	yy_column := yy_column + 1
--|#line 224 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 224")
end

							set_start_condition (COMMENT)
							
end
else
if yy_act = 32 then
	yy_column := yy_column + 1
--|#line 227 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 227")
end

							create last_string_value.make (32)
							set_start_condition (SC_DOMAIN_LITERAL)
							
else
	yy_column := yy_column + 1
--|#line 231 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 231")
end
 --"
							create last_string_value.make (32)
							set_start_condition (SC_QUOTED_STRING)
							
end
end
else
if yy_act <= 35 then
if yy_act = 34 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 235 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 235")
end
-- White space, ignore
else
yy_set_column (1)
--|#line 236 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 236")
end
-- Folded-line white space, ignore
end
else
if yy_act = 36 then
	yy_line := yy_line + 1
	yy_column := 1
--|#line 237 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 237")
end

							set_start_condition (INITIAL)
							to_condition := 0
							last_token := CRLF
							
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 242 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 242")
end
 --"
							last_token := MIME_ATOM
							if encoded_word_scanner.is_encoded_word (text) then
								last_string_value := encoded_word_scanner.decode_word (text)
							else
								last_string_value := text
							end
							
end
end
end
else
if yy_act <= 41 then
if yy_act <= 39 then
if yy_act = 38 then
	yy_column := yy_column + 1
--|#line 250 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 250")
end
 -- just return every other character
							last_token := text.item (1).code
							
else
	yy_column := yy_column + 1
--|#line 254 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 254")
end
 last_token := Semicolon_code 
end
else
if yy_act = 40 then
	yy_column := yy_column + 1
--|#line 255 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 255")
end
 last_token := Equal_code 
else
	yy_column := yy_column + 1
--|#line 256 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 256")
end

							to_condition := PARAMETER
							set_start_condition (COMMENT)
							
end
end
else
if yy_act <= 43 then
if yy_act = 42 then
	yy_column := yy_column + 1
--|#line 260 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 260")
end
 --"
							create last_string_value.make (32)
							to_condition := PARAMETER
							set_start_condition (SC_QUOTED_STRING)
							
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 265 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 265")
end
-- White space, ignore
end
else
yy_set_column (1)
--|#line 266 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 266")
end
-- Folded-line white space, ignore
end
end
end
else
if yy_act <= 51 then
if yy_act <= 48 then
if yy_act <= 46 then
if yy_act = 45 then
	yy_line := yy_line + 1
	yy_column := 1
--|#line 267 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 267")
end

							set_start_condition (INITIAL)
							to_condition := 0
							last_token := CRLF
							
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 272 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 272")
end
 --"
							last_string_value := text
							last_token := MIME_ATOM
							
end
else
if yy_act = 47 then
	yy_column := yy_column + 1
--|#line 276 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 276")
end
 -- ignore all other stuff??
							last_token := text.item (1).code
							
else
	yy_column := yy_column + 3
--|#line 285 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 285")
end
last_token := KW_SUN
end
end
else
if yy_act <= 50 then
if yy_act = 49 then
	yy_column := yy_column + 3
--|#line 286 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 286")
end
last_token := KW_MON
else
	yy_column := yy_column + 3
--|#line 287 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 287")
end
last_token := KW_TUE
end
else
	yy_column := yy_column + 3
--|#line 288 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 288")
end
last_token := KW_WED
end
end
else
if yy_act <= 55 then
if yy_act <= 53 then
if yy_act = 52 then
	yy_column := yy_column + 3
--|#line 289 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 289")
end
last_token := KW_THU
else
	yy_column := yy_column + 3
--|#line 290 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 290")
end
last_token := KW_FRI
end
else
if yy_act = 54 then
	yy_column := yy_column + 3
--|#line 291 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 291")
end
last_token := KW_SAT
else
	yy_column := yy_column + 6
--|#line 292 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 292")
end
last_token := KW_SUN
end
end
else
if yy_act <= 57 then
if yy_act = 56 then
	yy_column := yy_column + 6
--|#line 293 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 293")
end
last_token := KW_MON
else
	yy_column := yy_column + 7
--|#line 294 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 294")
end
last_token := KW_TUE
end
else
	yy_column := yy_column + 9
--|#line 295 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 295")
end
last_token := KW_WED
end
end
end
end
end
else
if yy_act <= 87 then
if yy_act <= 73 then
if yy_act <= 66 then
if yy_act <= 62 then
if yy_act <= 60 then
if yy_act = 59 then
	yy_column := yy_column + 8
--|#line 296 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 296")
end
last_token := KW_THU
else
	yy_column := yy_column + 6
--|#line 297 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 297")
end
last_token := KW_FRI
end
else
if yy_act = 61 then
	yy_column := yy_column + 8
--|#line 298 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 298")
end
last_token := KW_SAT
else
	yy_column := yy_column + 3
--|#line 299 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 299")
end
last_token := MONTH; last_integer_value := 1
end
end
else
if yy_act <= 64 then
if yy_act = 63 then
	yy_column := yy_column + 3
--|#line 300 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 300")
end
last_token := MONTH; last_integer_value := 2
else
	yy_column := yy_column + 3
--|#line 301 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 301")
end
last_token := MONTH; last_integer_value := 3
end
else
if yy_act = 65 then
	yy_column := yy_column + 3
--|#line 302 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 302")
end
last_token := MONTH; last_integer_value := 4
else
	yy_column := yy_column + 3
--|#line 303 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 303")
end
last_token := MONTH; last_integer_value := 5
end
end
end
else
if yy_act <= 70 then
if yy_act <= 68 then
if yy_act = 67 then
	yy_column := yy_column + 3
--|#line 304 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 304")
end
last_token := MONTH; last_integer_value := 6
else
	yy_column := yy_column + 3
--|#line 305 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 305")
end
last_token := MONTH; last_integer_value := 7
end
else
if yy_act = 69 then
	yy_column := yy_column + 3
--|#line 306 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 306")
end
last_token := MONTH; last_integer_value := 8
else
	yy_column := yy_column + 3
--|#line 307 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 307")
end
last_token := MONTH; last_integer_value := 9
end
end
else
if yy_act <= 72 then
if yy_act = 71 then
	yy_column := yy_column + 3
--|#line 308 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 308")
end
last_token := MONTH; last_integer_value := 10
else
	yy_column := yy_column + 3
--|#line 309 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 309")
end
last_token := MONTH; last_integer_value := 11
end
else
	yy_column := yy_column + 3
--|#line 310 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 310")
end
last_token := MONTH; last_integer_value := 12
end
end
end
else
if yy_act <= 80 then
if yy_act <= 77 then
if yy_act <= 75 then
if yy_act = 74 then
	yy_column := yy_column + 3
--|#line 311 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 311")
end
last_token := NUMBER; last_integer_value := 0
else
	yy_column := yy_column + 2
--|#line 312 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 312")
end
last_token := NUMBER; last_integer_value := 0
end
else
if yy_act = 76 then
	yy_column := yy_column + 3
--|#line 313 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 313")
end
last_token := NUMBER; last_integer_value := -5
else
	yy_column := yy_column + 3
--|#line 314 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 314")
end
last_token := NUMBER; last_integer_value := -4
end
end
else
if yy_act <= 79 then
if yy_act = 78 then
	yy_column := yy_column + 3
--|#line 315 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 315")
end
last_token := NUMBER; last_integer_value := -6
else
	yy_column := yy_column + 3
--|#line 316 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 316")
end
last_token := NUMBER; last_integer_value := -5
end
else
	yy_column := yy_column + 3
--|#line 317 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 317")
end
last_token := NUMBER; last_integer_value := -7
end
end
else
if yy_act <= 84 then
if yy_act <= 82 then
if yy_act = 81 then
	yy_column := yy_column + 3
--|#line 318 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 318")
end
last_token := NUMBER; last_integer_value := -6
else
	yy_column := yy_column + 3
--|#line 319 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 319")
end
last_token := NUMBER; last_integer_value := -8
end
else
if yy_act = 83 then
	yy_column := yy_column + 3
--|#line 320 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 320")
end
last_token := NUMBER; last_integer_value := -7
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 321 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 321")
end
 -- parse these time zones, but ignore them
						  last_token := NUMBER; last_string_value := text; last_integer_value := 0
						  
end
end
else
if yy_act <= 86 then
if yy_act = 85 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 324 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 324")
end
 -- finally, parse the shit spammers spew out like time zone XXXXXXXXXXXX
						  last_token := NUMBER; last_string_value := text; last_integer_value := 0
						  
else
	yy_column := yy_column + 1
--|#line 327 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 327")
end
last_token := Comma_code
end
else
	yy_column := yy_column + 1
--|#line 328 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 328")
end
last_token := Colon_code
end
end
end
end
else
if yy_act <= 101 then
if yy_act <= 94 then
if yy_act <= 91 then
if yy_act <= 89 then
if yy_act = 88 then
	yy_column := yy_column + 1
--|#line 329 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 329")
end
last_token := Minus_code
else
	yy_column := yy_column + 1
--|#line 330 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 330")
end

						  last_token := Semicolon_code
						  set_start_condition (STRUCTURED_FIELD_BODY)
						  
end
else
if yy_act = 90 then
	yy_column := yy_column + 1
--|#line 334 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 334")
end
 -- " we use this to recognize some s**t
						  last_token := Double_quote_code
						  
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 337 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 337")
end
-- (Folded-line) white space, ignore
end
end
else
if yy_act <= 93 then
if yy_act = 92 then
yy_set_column (1)
--|#line 338 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 338")
end
-- (Folded-line) white space, ignore
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 339 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 339")
end

						  last_integer_value := text.to_integer
						  last_token := NUMBER
						  
end
else
	yy_column := yy_column + 1
--|#line 343 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 343")
end

						  to_condition := DATE
						  set_start_condition (COMMENT)
						  
end
end
else
if yy_act <= 98 then
if yy_act <= 96 then
if yy_act = 95 then
	yy_line := yy_line + 1
	yy_column := 1
--|#line 347 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 347")
end

						  set_start_condition (INITIAL)
						  to_condition := 0
						  last_token := CRLF
						  
else
	yy_column := yy_column + 2
--|#line 356 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 356")
end
 
end
else
if yy_act = 97 then
	yy_column := yy_column + 2
--|#line 357 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 357")
end
 
else
	yy_column := yy_column + 1
--|#line 358 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 358")
end

							if nested_comment_count = 0 then
								set_start_condition (to_condition)
							else
								nested_comment_count := nested_comment_count - 1
							end
							
end
end
else
if yy_act <= 100 then
if yy_act = 99 then
	yy_column := yy_column + 1
--|#line 365 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 365")
end
 nested_comment_count := nested_comment_count + 1 
else
yy_set_line_column
--|#line 366 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 366")
end
 
end
else
	yy_column := yy_column + 2
--|#line 372 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 372")
end
 last_string_value.append_character (text.item (2)) 
end
end
end
else
if yy_act <= 108 then
if yy_act <= 105 then
if yy_act <= 103 then
if yy_act = 102 then
	yy_column := yy_column + 1
--|#line 373 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 373")
end

							set_start_condition (to_condition)
							last_token := DOMAIN_LITERAL
							
else
yy_set_column (1)
--|#line 377 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 377")
end

							last_string_value.append_character (' ')
							
end
else
if yy_act = 104 then
yy_set_line_column
--|#line 380 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 380")
end
 last_string_value.append_string (text) 
else
	yy_column := yy_column + 2
--|#line 385 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 385")
end
 last_string_value.append_character (text.item (2)) 
end
end
else
if yy_act <= 107 then
if yy_act = 106 then
	yy_column := yy_column + 1
--|#line 386 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 386")
end
 --"
							set_start_condition (to_condition)
							last_token := QUOTED_STRING
							
else
yy_set_column (1)
--|#line 390 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 390")
end

							last_string_value.append_character (' ')
							
end
else
yy_set_line_column
--|#line 393 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 393")
end
 --"
							last_string_value.append_string (text)
							
end
end
else
if yy_act <= 112 then
if yy_act <= 110 then
if yy_act = 109 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 400 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 400")
end

							if encoded_word_scanner.is_encoded_word (text) then
								if prev_word_was_encoded then
									from
									until
										last_string_value.is_empty or else
										(last_string_value.item (last_string_value.count) /= ' ' and then
										last_string_value.item (last_string_value.count) /= '%T')
									loop
										last_string_value.keep_head (last_string_value.count - 1)
									end
								end
								last_string_value.append_string (encoded_word_scanner.decode_word (text))
								prev_word_was_encoded := True
							else
								last_string_value.append_string (text)
								prev_word_was_encoded := False
							end
							
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 419 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 419")
end
last_string_value.append_string (text)
end
else
if yy_act = 111 then
yy_set_column (1)
--|#line 420 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 420")
end
 -- Folded line
							last_string_value.append_character (' ')
							
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 423 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 423")
end

							if last_string_value.is_empty then
								last_token := CRLF
							else
								less (0)
								last_token := FIELD_BODY
							end
							to_condition := 0
							set_start_condition (INITIAL)
							prev_word_was_encoded := False
							
end
end
else
if yy_act <= 114 then
if yy_act = 113 then
	yy_column := yy_column + 1
--|#line 434 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 434")
end
-- ignore lone CR's
else
	yy_column := yy_column + 1
--|#line 440 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 440")
end
-- ignore all other charcters, i.e. ascii unprintables and high ascii
end
else
yy_set_line_column
--|#line 0 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 0")
end
last_token := yyError_token
fatal_error ("scanner jammed")
end
end
end
end
end
end
		end

	yy_execute_eof_action (yy_sc: INTEGER) is
			-- Execute EOF semantic action.
		do
			inspect yy_sc
when 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 then
--|#line 0 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 0")
end
 terminate 
			else
				terminate
			end
		end

feature {NONE} -- Table templates

	yy_nxt_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,   22,   23,   24,   25,   38,   39,   40,   38,   39,
			   40,   77,   78,  377,   79,   27,   67,   68,   67,   68,
			  142,  143,  144,   28,   29,   30,  198,   31,   77,   78,
			   32,   79,  114,  119,   33,  161,  177,  120,   34,   35,
			   36,   71,   72,  123,  115,  124,  164,   71,   72,   22,
			   22,   23,   24,   25,   80,   69,  149,   69,  159,  153,
			  161,  169,  160,  162,   27,  158,  148,  376,  161,  161,
			  167,   80,   28,   29,   30,  161,   31,  163,  207,   32,
			  165,  176,  168,   33,   73,   74,  161,   34,   35,   36,
			   73,   74,  161,  161,  166,  178,  161,  170,   22,   41,

			   42,   43,   44,  161,   46,   47,   41,  180,   41,  179,
			   41,  181,  183,   41,   41,   41,  171,   41,  161,   41,
			  185,  194,  195,  161,  184,  199,  182,  375,  161,  201,
			  186,  161,  202,  161,  204,  161,  200,  161,  205,  374,
			  161,  203,  161,   48,   41,   41,  161,   41,   41,   42,
			   43,   44,  161,   46,   47,   41,  161,   41,  172,   41,
			  206,  173,   41,   41,   41,  161,   41,  209,   41,  208,
			  214,  210,  174,  211,  216,  175,  215,  161,  161,  222,
			  161,  212,  161,  225,  161,  161,  161,  213,  373,  161,
			  161,  161,   48,   41,   41,  217,   41,   49,   50,   51,

			   52,  161,   54,   55,   49,  161,   49,  372,  226,   49,
			  218,   49,   49,   49,   49,   49,   49,   49,  161,  219,
			  220,  221,  223,  224,  297,  289,  371,  161,  161,  161,
			  161,  161,  298,  370,  311,  161,  290,  291,  369,  299,
			  312,   56,   49,   49,   49,   50,   51,   52,  368,   54,
			   55,   49,  367,   49,  366,  365,   49,  364,   49,   49,
			   49,   49,   49,   49,   49,  132,  363,  362,  361,  360,
			  136,  132,  132,  132,  132,  136,  132,  136,  359,  358,
			  357,  136,  356,  355,  136,  354,  353,  352,   56,   49,
			   49,   57,   58,   59,   60,  351,   62,   63,   57,  350,

			   57,  349,  348,   57,  347,   57,   64,   57,   65,   57,
			   57,   57,  140,  346,  345,  344,  343,  140,  342,  140,
			  341,  340,  339,  140,  338,  337,  140,  336,  335,  334,
			  333,  332,  331,  330,  329,   57,   57,   57,   57,   58,
			   59,   60,  328,   62,   63,   57,  327,   57,  326,  325,
			   57,  324,   57,   64,   57,   65,   57,   57,   57,  323,
			  322,  321,  320,  319,  318,  317,  316,  315,  314,  313,
			  310,  309,  308,  307,  306,  305,  304,  303,  302,  301,
			  300,  296,   57,   57,   57,   75,   81,   82,   83,   75,
			   84,   85,   75,   86,   87,   88,   75,   75,   89,   90,

			   91,   75,   75,   75,   75,   75,   92,   93,   94,   95,
			   96,   97,   98,   93,   93,   99,   93,   93,  100,  101,
			  102,  103,   93,  104,  105,  106,   93,  107,   93,   75,
			   75,   75,  108,   75,   26,   26,   26,   26,   26,   26,
			   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,
			   26,   37,   37,   37,   37,   37,   37,   37,   37,   37,
			   37,   37,   37,   37,   37,   37,   37,   37,   45,   45,
			   45,   45,   45,   45,   45,   45,   45,   45,   45,   45,
			   45,   45,   45,   45,   45,   53,   53,   53,   53,   53,
			   53,   53,   53,   53,   53,   53,   53,   53,   53,   53,

			   53,   53,   61,   61,   61,   61,   61,   61,   61,   61,
			   61,   61,   61,   61,   61,   61,   61,   61,   61,   66,
			   66,   66,   66,   66,   66,   66,   66,   66,   66,   66,
			   66,   66,   66,   66,   66,   66,   70,   70,   70,   70,
			   70,   70,   70,   70,   70,   70,   70,   70,   70,   70,
			   70,   70,   70,   75,   75,   75,   75,   75,   75,   75,
			   75,   75,   75,   75,   75,   75,   75,   75,   75,   75,
			   76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
			   76,   76,   76,   76,   76,   76,   76,  111,  111,  111,
			  111,  111,  111,  111,  111,  111,  111,  111,  111,  111,

			  111,  125,  295,  125,  125,  125,  125,  125,  125,  125,
			  125,  125,  125,  125,  125,  125,  125,  125,  141,  141,
			  141,  141,  294,  293,  141,  141,  141,  141,  141,  141,
			  141,  141,  141,  141,  141,  144,  144,  144,  144,  144,
			  144,  144,  144,  144,  144,  144,  144,  144,  144,  144,
			  292,  144,  147,  147,  147,  147,  147,  147,  147,  147,
			  147,  147,  147,  147,  147,  147,  147,  147,  147,  149,
			  149,  149,  288,  149,  149,  149,  149,  149,  149,  149,
			  149,  149,  149,  149,  149,  149,  152,  152,  152,  152,
			  152,  152,  152,  152,  152,  152,  152,  152,  152,  152,

			  152,  152,  152,  287,  286,  285,  284,  283,  282,  281,
			  280,  279,  278,  277,  276,  275,  274,  273,  272,  271,
			  270,  269,  268,  267,  266,  265,  264,  263,  262,  261,
			  260,  259,  258,  257,  256,  255,  254,  253,  252,  251,
			  250,  249,  248,  247,  246,  245,  244,  243,  242,  241,
			  240,  239,  238,  237,  236,  235,  234,  233,  232,  231,
			  230,  229,  228,  227,  161,  161,  157,  155,  155,  154,
			  150,  150,  145,  145,  138,  138,  137,  134,  134,  133,
			  130,  130,  129,  127,  127,  126,  197,  196,  193,  192,
			  191,  190,  189,  188,  187,  112,  109,  161,  157,  157,

			  157,  156,  155,  154,  151,  150,  146,  145,  139,  138,
			  137,  135,  134,  133,  131,  130,  129,  128,  127,  126,
			  122,  121,  118,  117,  116,  113,  112,  110,  109,  377,
			   21,  377,  377,  377,  377,  377,  377,  377,  377,  377,
			  377,  377,  377,  377,  377,  377,  377,  377,  377,  377,
			  377,  377,  377,  377,  377,  377,  377,  377,  377,  377,
			  377,  377,  377,  377,  377,  377,  377,  377,  377,  377,
			  377,  377,  377,  377,  377,  377,  377,  377,  377,  377, yy_Dummy>>)
		end

	yy_chk_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    3,    3,    3,    4,    4,
			    4,   17,   17,    0,   17,    1,   11,   11,   12,   12,
			   69,   69,   73,    1,    1,    1,  399,    1,   18,   18,
			    1,   18,   29,   33,    1,  398,  102,   33,    1,    1,
			    1,   13,   13,   36,   29,   36,   95,   14,   14,    1,
			    2,    2,    2,    2,   17,   11,   80,   12,   92,   80,
			  102,   98,   92,   94,    2,  397,   73,  375,   95,   92,
			   97,   18,    2,    2,    2,   98,    2,   94,  168,    2,
			   96,  101,   97,    2,   13,   13,   94,    2,    2,    2,
			   14,   14,   97,  101,   96,  103,  168,   99,    2,    5,

			    5,    5,    5,   96,    5,    5,    5,  104,    5,  103,
			    5,  104,  105,    5,    5,    5,   99,    5,  103,    5,
			  106,  121,  121,   99,  105,  159,  104,  374,  106,  162,
			  107,  105,  163,  104,  165,  159,  160,  162,  166,  373,
			  163,  164,  165,    5,    5,    5,  166,    5,    6,    6,
			    6,    6,  107,    6,    6,    6,  160,    6,  100,    6,
			  167,  100,    6,    6,    6,  164,    6,  170,    6,  169,
			  173,  171,  100,  171,  175,  100,  174,  169,  173,  181,
			  170,  172,  175,  184,  100,  167,  171,  172,  372,  174,
			  181,  172,    6,    6,    6,  176,    6,    7,    7,    7,

			    7,  176,    7,    7,    7,  184,    7,  371,  186,    7,
			  177,    7,    7,    7,    7,    7,    7,    7,  177,  178,
			  179,  180,  182,  183,  285,  278,  370,  178,  179,  180,
			  183,  186,  285,  368,  299,  182,  278,  278,  367,  285,
			  299,    7,    7,    7,    8,    8,    8,    8,  364,    8,
			    8,    8,  363,    8,  362,  361,    8,  360,    8,    8,
			    8,    8,    8,    8,    8,  389,  359,  358,  356,  355,
			  390,  389,  389,  389,  389,  390,  389,  390,  354,  353,
			  352,  390,  351,  350,  390,  348,  347,  345,    8,    8,
			    8,    9,    9,    9,    9,  344,    9,    9,    9,  343,

			    9,  342,  341,    9,  340,    9,    9,    9,    9,    9,
			    9,    9,  391,  339,  338,  336,  334,  391,  333,  391,
			  332,  331,  329,  391,  328,  326,  391,  325,  324,  323,
			  322,  321,  320,  319,  318,    9,    9,    9,   10,   10,
			   10,   10,  317,   10,   10,   10,  316,   10,  315,  313,
			   10,  312,   10,   10,   10,   10,   10,   10,   10,  311,
			  310,  309,  307,  306,  305,  304,  303,  302,  301,  300,
			  298,  297,  296,  293,  292,  291,  290,  289,  288,  287,
			  286,  284,   10,   10,   10,   19,   19,   19,   19,   19,
			   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,

			   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
			   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
			   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
			   19,   19,   19,   19,  378,  378,  378,  378,  378,  378,
			  378,  378,  378,  378,  378,  378,  378,  378,  378,  378,
			  378,  379,  379,  379,  379,  379,  379,  379,  379,  379,
			  379,  379,  379,  379,  379,  379,  379,  379,  380,  380,
			  380,  380,  380,  380,  380,  380,  380,  380,  380,  380,
			  380,  380,  380,  380,  380,  381,  381,  381,  381,  381,
			  381,  381,  381,  381,  381,  381,  381,  381,  381,  381,

			  381,  381,  382,  382,  382,  382,  382,  382,  382,  382,
			  382,  382,  382,  382,  382,  382,  382,  382,  382,  383,
			  383,  383,  383,  383,  383,  383,  383,  383,  383,  383,
			  383,  383,  383,  383,  383,  383,  384,  384,  384,  384,
			  384,  384,  384,  384,  384,  384,  384,  384,  384,  384,
			  384,  384,  384,  385,  385,  385,  385,  385,  385,  385,
			  385,  385,  385,  385,  385,  385,  385,  385,  385,  385,
			  386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
			  386,  386,  386,  386,  386,  386,  386,  387,  387,  387,
			  387,  387,  387,  387,  387,  387,  387,  387,  387,  387,

			  387,  388,  282,  388,  388,  388,  388,  388,  388,  388,
			  388,  388,  388,  388,  388,  388,  388,  388,  392,  392,
			  392,  392,  281,  280,  392,  392,  392,  392,  392,  392,
			  392,  392,  392,  392,  392,  393,  393,  393,  393,  393,
			  393,  393,  393,  393,  393,  393,  393,  393,  393,  393,
			  279,  393,  394,  394,  394,  394,  394,  394,  394,  394,
			  394,  394,  394,  394,  394,  394,  394,  394,  394,  395,
			  395,  395,  277,  395,  395,  395,  395,  395,  395,  395,
			  395,  395,  395,  395,  395,  395,  396,  396,  396,  396,
			  396,  396,  396,  396,  396,  396,  396,  396,  396,  396,

			  396,  396,  396,  276,  275,  274,  273,  272,  271,  269,
			  266,  264,  263,  262,  261,  260,  259,  258,  257,  256,
			  255,  254,  253,  252,  251,  250,  249,  248,  247,  246,
			  245,  244,  243,  242,  241,  240,  239,  238,  237,  236,
			  235,  234,  233,  232,  231,  230,  227,  226,  225,  224,
			  223,  221,  215,  207,  197,  196,  195,  194,  193,  192,
			  191,  190,  189,  188,  185,  158,  157,  156,  155,  154,
			  151,  150,  146,  145,  139,  138,  137,  135,  134,  133,
			  131,  130,  129,  128,  127,  126,  124,  122,  120,  119,
			  118,  117,  116,  115,  113,  112,  109,   93,   89,   88,

			   86,   83,   82,   81,   78,   77,   72,   71,   60,   59,
			   58,   52,   51,   50,   44,   43,   42,   40,   39,   38,
			   35,   34,   32,   31,   30,   28,   27,   25,   23,   21,
			  377,  377,  377,  377,  377,  377,  377,  377,  377,  377,
			  377,  377,  377,  377,  377,  377,  377,  377,  377,  377,
			  377,  377,  377,  377,  377,  377,  377,  377,  377,  377,
			  377,  377,  377,  377,  377,  377,  377,  377,  377,  377,
			  377,  377,  377,  377,  377,  377,  377,  377,  377,  377, yy_Dummy>>)
		end

	yy_base_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    0,   49,    3,    6,   98,  147,  196,  243,  290,
			  337,    9,   11,   38,   44,    0,    0,    8,   25,  384,
			    0,  829,  830,  826,  830,  824,    0,  824,  801,    8,
			  802,  785,  795,    7,  795,  794,    7,    0,  817,  816,
			  814,  830,  814,  813,  811,    0,  830,  830,  830,  830,
			  811,  810,  808,    0,  830,  830,  830,  830,  808,  807,
			  805,    0,  830,  830,  830,  830,    0,  830,  830,   13,
			    0,  805,  803,   19,  830,  830,    0,  803,  801,  830,
			   53,  801,  800,  798,  830,  830,  786,  830,  785,  784,
			  830,  830,   21,  749,   38,   20,   55,   44,   27,   75,

			  136,   45,   12,   70,   85,   83,   80,  104,    0,  794,
			  830,    0,  793,  770,    0,  758,  752,  755,  779,  750,
			  754,   82,  752,    0,  764,    0,  783,  782,  781,  780,
			  779,  778,    0,  777,  776,  775,    0,  774,  773,  772,
			    0,    0,  830,  830,    0,  771,  770,    0,  830,    0,
			  769,  768,    0,  830,  767,  766,  765,  752,  717,   87,
			  108,    0,   89,   92,  117,   94,   98,  137,   48,  129,
			  132,  138,  143,  130,  141,  134,  153,  170,  179,  180,
			  181,  142,  187,  182,  157,  716,  183,    0,  723,  736,
			  727,  726,  720,  732,  731,  715,  730,  719,    0,    0,

			    0,    0,    0,    0,    0,    0,    0,  728,    0,    0,
			    0,    0,    0,    0,    0,  727,    0,    0,    0,    0,
			    0,  710,    0,  725,  711,  709,  712,  720,    0,    0,
			  709,  722,  732,  707,  703,  714,  700,  716,  715,  698,
			  713,  695,  708,  706,  696,  705,  701,  686,  687,  691,
			  687,  697,  679,  678,  696,  676,  694,  696,  678,  676,
			  685,  688,  687,  701,  700,    0,  684,    0,    0,  687,
			    0,  686,  663,  681,  694,  677,  692,  634,  198,  613,
			  585,  578,  558,    0,  359,  199,  350,  349,  339,  339,
			  350,  349,  352,  362,    0,    0,  328,  341,  344,  196,

			  343,  343,  337,  330,  328,  329,  323,  336,    0,  322,
			  325,  337,  314,  324,    0,  312,  312,  309,  309,  304,
			  297,  294,  302,  294,  302,  316,  290,    0,  280,  296,
			    0,  297,  284,  278,  277,    0,  276,    0,  303,  275,
			  268,  263,  272,  272,  265,  247,    0,  261,  255,    0,
			  257,  247,  244,  249,  238,  231,  244,    0,  232,  236,
			  246,  229,  226,  216,  222,    0,    0,  203,  198,    0,
			  202,  171,  163,  109,   92,   39,    0,  830,  433,  450,
			  467,  484,  501,  518,  535,  552,  569,  584,  600,  262,
			  267,  309,  617,  634,  651,  668,  685,   51,   21,   12, yy_Dummy>>)
		end

	yy_def_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,  378,  378,  379,  379,  380,  380,  381,  381,  382,
			  382,  383,  383,  384,  384,  385,  385,  386,  386,  377,
			   19,  377,  377,  377,  377,  377,  387,  377,  387,  387,
			  387,  387,  387,  387,  387,  387,  387,  388,  377,  377,
			  377,  377,  377,  377,  377,  389,  377,  377,  377,  377,
			  377,  377,  377,  390,  377,  377,  377,  377,  377,  377,
			  377,  391,  377,  377,  377,  377,  392,  377,  377,  392,
			  393,  393,  393,  394,  377,  377,  395,  395,  395,  377,
			  396,  377,  377,  377,  377,  377,  377,  377,  377,  377,
			  377,  377,  397,  397,  397,  397,  397,  397,  397,  397,

			  397,  397,  397,  397,  397,  397,  397,  397,  398,  377,
			  377,  387,  377,  387,  387,  387,  387,  387,  387,  387,
			  387,  387,  387,  387,  387,  388,  377,  377,  377,  377,
			  377,  377,  389,  377,  377,  377,  390,  377,  377,  377,
			  391,  392,  377,  377,  393,  393,  393,  393,  377,  395,
			  395,  395,  395,  377,  377,  377,  377,  377,  399,  399,
			  399,  398,  399,  399,  399,  399,  399,  399,  399,  399,
			  399,  399,  399,  399,  399,  399,  399,  399,  399,  399,
			  399,  399,  399,  399,  399,  399,  399,  387,  387,  387,
			  387,  387,  387,  387,  387,  387,  387,  387,  398,  398,

			  398,  398,  398,  398,  398,  398,  398,  398,  398,  398,
			  398,  398,  398,  398,  398,  398,  398,  398,  398,  398,
			  398,  398,  398,  398,  398,  398,  398,  387,  387,  387,
			  387,  387,  387,  387,  387,  387,  387,  398,  398,  398,
			  398,  398,  398,  398,  387,  387,  387,  387,  387,  387,
			  387,  387,  398,  398,  398,  398,  398,  398,  398,  387,
			  387,  387,  387,  387,  387,  387,  387,  398,  398,  398,
			  398,  398,  398,  398,  387,  387,  387,  387,  387,  387,
			  387,  398,  398,  398,  398,  387,  387,  387,  387,  387,
			  387,  387,  387,  387,  398,  398,  398,  387,  387,  387,

			  387,  387,  387,  387,  387,  387,  387,  387,  398,  387,
			  387,  387,  387,  387,  387,  387,  387,  387,  387,  387,
			  387,  387,  387,  387,  387,  387,  387,  387,  387,  387,
			  387,  387,  387,  387,  387,  387,  387,  387,  387,  387,
			  387,  387,  387,  387,  387,  387,  387,  387,  387,  387,
			  387,  387,  387,  387,  387,  387,  387,  387,  387,  387,
			  387,  387,  387,  387,  387,  387,  387,  387,  387,  387,
			  387,  387,  387,  387,  387,  387,  387,    0,  377,  377,
			  377,  377,  377,  377,  377,  377,  377,  377,  377,  377,
			  377,  377,  377,  377,  377,  377,  377,  377,  377,  377, yy_Dummy>>)
		end

	yy_ec_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    2,
			    3,    1,    1,    4,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    2,    5,    6,    5,    5,    5,    5,    5,
			    7,    8,    5,    9,   10,   11,   12,   13,   14,   14,
			   14,   14,   14,   14,   14,   14,   14,   14,   15,   16,
			   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,
			   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,
			   37,   32,   38,   39,   40,   41,   42,   43,   32,   44,
			   32,   45,   46,   47,    5,   48,    5,   22,   23,   24,

			   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
			   35,   36,   37,   32,   38,   39,   40,   41,   42,   43,
			   32,   44,   32,    5,    5,    5,    5,   49,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1, yy_Dummy>>)
		end

	yy_meta_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    1,    2,    2,    2,    3,    4,    5,    6,    3,
			    7,    3,    8,    9,   10,    1,    7,    7,   11,    7,
			   12,   13,   14,   14,   14,   14,   14,   14,   14,   14,
			   14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
			   14,   14,   14,   14,   14,    7,   15,   16,   14,   17, yy_Dummy>>)
		end

	yy_accept_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,  116,  114,    1,   22,  114,   20,   21,   20,   20,
			   20,   20,   20,   20,   20,   20,   20,  109,  110,  112,
			  113,   30,   26,   28,   30,   29,   25,   23,   24,   38,
			   34,   36,   38,   37,   33,   31,   32,   47,   43,   45,
			   47,   46,   42,   41,   39,   40,  100,   99,   98,  100,
			  104,  104,  104,  104,  102,  115,  108,  108,  108,  106,
			  108,   91,   95,  115,   90,   94,  115,   86,   88,   93,
			   87,   89,   84,   84,   84,   84,   84,   84,   84,   84,

			   84,   84,   84,   84,   84,   84,   84,   84,   85,    1,
			   22,   20,   21,   20,    3,   20,   20,   20,   20,   20,
			   20,   20,   20,   18,   20,  109,  110,  111,  112,   26,
			   27,   28,   29,   34,   35,   36,   37,   43,   44,   45,
			   46,  100,   96,   97,  104,  103,  104,  101,  101,  108,
			  107,  108,  105,  105,   91,   92,   95,   93,   84,   84,
			   84,   85,   84,   84,   84,   84,   84,   84,   84,   84,
			   84,   84,   84,   84,   84,   84,   84,   84,   84,   84,
			   84,   84,   84,   84,   84,   75,   84,    2,   20,   20,
			   20,   20,   20,   20,   20,   20,   20,   20,   84,   65,

			   69,   79,   78,   73,   77,   76,   63,   53,   74,   62,
			   68,   67,   64,   66,   81,   49,   80,   72,   71,   83,
			   82,   54,   70,   48,   52,   50,   51,   20,    8,    9,
			   20,   20,   20,   20,   20,   20,   20,   85,   85,   85,
			   85,   85,   85,   85,   20,   20,   20,   20,   20,   20,
			   20,   20,   85,   85,   85,   85,   85,   85,   85,   20,
			   20,   20,   20,   20,   20,   17,   20,   60,   56,   85,
			   55,   85,   85,   85,   20,   20,   20,   20,   20,   20,
			   20,   85,   85,   57,   85,   20,   20,   20,   20,   20,
			   20,   20,   20,   20,   61,   59,   85,   20,   20,   20,

			   20,   20,   20,   20,   20,   20,   20,   20,   58,   20,
			   20,   20,   20,   20,   11,   20,   20,   20,   20,   20,
			   20,   20,   20,   20,   20,   20,   20,   13,   20,   20,
			   16,   20,   20,   20,   20,    7,   20,   12,   20,   20,
			   20,   20,   20,   20,   20,   20,   15,   20,   20,    5,
			   20,   20,   20,   20,   20,   20,   20,   14,   20,   20,
			   20,   20,   20,   20,   20,   10,   19,   20,   20,    4,
			   20,   20,   20,   20,   20,   20,    6,    0, yy_Dummy>>)
		end

feature {NONE} -- Constants

	yyJam_base: INTEGER is 830
			-- Position in `yy_nxt'/`yy_chk' tables
			-- where default jam table starts

	yyJam_state: INTEGER is 377
			-- State id corresponding to jam state

	yyTemplate_mark: INTEGER is 378
			-- Mark between normal states and templates

	yyNull_equiv_class: INTEGER is 1
			-- Equivalence code for NULL character

	yyReject_used: BOOLEAN is false
			-- Is `reject' called?

	yyVariable_trail_context: BOOLEAN is false
			-- Is there a regular expression with
			-- both leading and trailing parts having
			-- variable length?

	yyReject_or_variable_trail_context: BOOLEAN is false
			-- Is `reject' called or is there a
			-- regular expression with both leading
			-- and trailing parts having variable length?

	yyNb_rules: INTEGER is 115
			-- Number of rules

	yyEnd_of_buffer: INTEGER is 116
			-- End of buffer rule code

	yyLine_used: BOOLEAN is true
			-- Are line and column numbers used?

	yyPosition_used: BOOLEAN is false
			-- Is `position' used?

	INITIAL: INTEGER is 0
	UNSTRUCTURED_FIELD_BODY: INTEGER is 1
	STRUCTURED_FIELD_BODY: INTEGER is 2
	MIME_FIELD_BODY: INTEGER is 3
	PARAMETER: INTEGER is 4
	COMMENT: INTEGER is 5
	SC_DOMAIN_LITERAL: INTEGER is 6
	NEXT_WORD: INTEGER is 7
	SC_QUOTED_STRING: INTEGER is 8
	DATE: INTEGER is 9
			-- Start condition codes

feature -- User-defined features



feature {NONE} -- Initialization

	make is
		do
			precursor
			create encoded_word_scanner.make
		end


feature -- Last returned data


feature -- Input

	new_mime_request_buffer (a_stream: EPX_CHARACTER_INPUT_STREAM): EPX_MIME_BUFFER is
			-- New input buffer for `a_stream'.
		require
			stream_not_void: a_stream /= Void
			stream_open: a_stream.is_open_read
		do
			create Result.make (a_stream)
		ensure
			new_buffer_not_void: Result /= Void
		end


feature -- Condition setting

	expect_date is
		do
			set_start_condition (DATE)
		end

	reset_start_condition is
			-- Used in error recovery to return to start condition.
		do
			set_start_condition (INITIAL)
		end

	start_parameter is
		do
			to_condition := PARAMETER
			set_start_condition (PARAMETER)
		end


feature {NONE} -- State during parsing

	call_enable_keyword_after_space: BOOLEAN
			-- Flag to call `enable_keyword_after_space' when encountered an ATOM.

	expect_keyword: BOOLEAN
			-- Treat certain atoms specially.

	expect_keyword_after_space: BOOLEAN
			-- Treat certain atoms specially after a space, crlf in
			-- folded-line or comment has been ecountered.

	to_condition: INTEGER
			-- Used by ':' to switch to correct field body parser.

	nested_comment_count: INTEGER
			-- Keep track of nested comments.

-- 	last_integer: INTEGER_REF

-- 	last_string: STRING is
-- 		do
-- 			Result ?= last_value
-- 		ensure
-- 			last_string_returned: Result /= Void
-- 		end

-- 	set_last_integer (value: INTEGER) is
-- 			-- Set `last_integer' and make sure `last_value' is this integer.
-- 		do
-- 			create last_integer
-- 			last_integer.set_item (value)
-- 			last_value := last_integer
-- 		ensure
-- 			new_integer: last_integer /= old last_integer
-- 			value_set: last_integer.item = value
-- 			last_value_is_integer: last_value = last_integer
-- 		end

	prev_word_was_encoded: BOOLEAN
			-- Used to skip white space between encoded-words in an
			-- unstructured field.


feature {NONE} -- Implementation

	to_canonical_field_name (a_field_name: STRING): STRING is
			-- Turn `a_field_name' into a canonical field name. A
			-- canonical field name as the first character in uppercase
			-- and every character after a '-' as well. All other
			-- characters are lower case.
		require
			a_field_name_not_empty: a_field_name /= Void and then not a_field_name.is_empty
		local
			c,
			prev_c: CHARACTER
			i: INTEGER
		do
			create Result.make_from_string (a_field_name)
			prev_c := Result.item (1)
			Result.put (as_upper (prev_c), 1)
			from
				i := 2
			until
				i > Result.count
			loop
				c := Result.item (i)
				if prev_c = '-' then
					Result.put (as_upper (c), i)
				else
					Result.put (as_lower (c), i)
				end
				prev_c := c
				i := i + 1
			end
		end


feature {NONE} -- RFC 2047 encoded stuff handling

	encoded_word_scanner: EPX_MIME_ENCODED_WORD_SCANNER


invariant

	never_a_keyword_in_start_condition:
		start_condition = INITIAL implies
			(not expect_keyword and not expect_keyword_after_space)
	encoded_word_scanner_not_void: encoded_word_scanner /= Void

end
